<template>
  <div class="light-container">
    <h2>เสาไฟสัญญาณ</h2>
    <v-container >
      <v-card class="pa-5 mb-5" v-for="(item, i) in lightList" :key="i">
        <h3>สัญญาณ</h3>
        <v-card v-for="(item2, i2) in item.lampList" :key="i2" variant="outlined" class="pa-2 mt-2">
          <v-row align="center">
            <v-col cols="4" align="center">
              <v-img :src="images[item2.lampType]" :width="item2.lampType === 'img1' ? '37px' : '60px'"></v-img>
            </v-col>
            <v-col cols="4">
              <label for="">วันที่ซ่อมบำรุงล่าสุด: </label>
              <label for="">{{ item2.maintDate || '-'}}</label><br>
              <label for="">วันที่สิ้นสุดการรับประกัน: </label>
              <label for="">{{ item2.gnteeDate || '-'}}</label><br>
            </v-col>
            <v-col cols="4">
              <label for="">ประเภทดวง: </label>
              <label for="">{{ item2.type === 'full' ? 'แบบเต็มดวง' : 'แบบลูกศร' || '-'}}</label><br>
            </v-col>
          </v-row>
        </v-card>
        <div class="pt-3"></div>
        <v-btn class="mx-2" dark color="primary" @click="showModalLight(i)">
          <v-icon dark> mdi-plus </v-icon>
        </v-btn>
        <div class="pt-3"></div>
        <v-form>
          <v-row>
            <v-col cols="auto">
              <v-checkbox
                v-model="item.hasLightHuman"
                :label="`มีสัญญาณไฟสําหรับคนเดินข้ามถนน`"
              ></v-checkbox>
            </v-col>
            <v-col cols="=auto">
              <v-checkbox
                v-model="item.hasButton"
                :label="`มีปุ่มกดสําหรับคนเดินข้ามถนน`"
              ></v-checkbox>
            </v-col>
          </v-row>
        </v-form>
      </v-card>
      <div class="center-element">
        <v-btn class="mx-2" fab dark color="green" @click="addLightList">
          <v-icon dark> mdi-plus </v-icon>
        </v-btn>
      </div>
    </v-container>
    <!-- modal light -->
    <v-dialog v-model="modalLight" width="50%">
      <v-card class="pa-3">
        <v-form-group>
          <v-radio-group v-model="currSetting.lampType" >
            <v-row>
              <v-col cols="3" align="center">
                <v-img :src="images.img1" width="37px"></v-img>
                <v-radio class="pt-2 justify-center" value="img1"></v-radio>
              </v-col>
              <v-col cols="3" align="center">
                <v-img :src="images.img2" width="60px"></v-img>
                <v-radio class="pt-2 justify-center" value="img2"></v-radio>
              </v-col>
              <v-col cols="3" align="center">
                <v-img :src="images.img3" width="60px"></v-img>
                <v-radio class="pt-2 justify-center" value="img3"></v-radio>
              </v-col>
              <v-col cols="3" align="center">
                <v-img :src="images.img4" width="60px"></v-img>
                <v-radio class="pt-2 justify-center" value="img4"></v-radio>
              </v-col>
            </v-row>
            <v-row class="pl-4">
              <v-col cols="6">
                <v-menu
                  ref="menu"
                  v-model="menu"
                  :close-on-content-click="false"
                  :return-value.sync="dates"
                  transition="scale-transition"
                  offset-y
                  min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-combobox
                      v-model="currSetting.maintDate"
                      chips
                      small-chips
                      label="วันที่ซ่อมบำรุงล่าสุด"
                      prepend-icon="mdi-calendar"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                    ></v-combobox>
                  </template>
                  <v-date-picker
                    v-model="currSetting.maintDate"
                    no-title
                    scrollable
                  >
                  </v-date-picker>
                </v-menu>
              </v-col>
              <v-col cols="6">
                <v-menu
                  ref="menu"
                  v-model="menu"
                  :close-on-content-click="false"
                  :return-value.sync="dates"
                  transition="scale-transition"
                  offset-y
                  min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-combobox
                      v-model="currSetting.gnteeDate"
                      chips
                      small-chips
                      label="วันที่สิ้นสุดการรับประกัน"
                      prepend-icon="mdi-calendar"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                    ></v-combobox>
                  </template>
                  <v-date-picker
                    v-model="currSetting.gnteeDate"
                    no-title
                    scrollable
                  >
                  </v-date-picker>
                </v-menu>
              </v-col>
            </v-row>
          </v-radio-group>
          <v-radio-group class="pl-4" v-model="currSetting.type">
              <v-radio value="full" label="แบบเต็มดวง"></v-radio>
              <v-radio value="arrow" label="แบบลูกศร"></v-radio>
            </v-radio-group>
        </v-form-group>
        <div class="center-element pt-3">
          <v-btn color="primary" @click="saveProcess">บันทึก</v-btn>
        </div>
      </v-card>
    </v-dialog>
    <!-- {{ lightList }} -->
  </div>
</template>

<script>
import MapComponent from '~/components/MapComponent'

export default {
  components: {
    MapComponent,
  },
  data() {
    return {
      // SLPdata:[

      // ],
      images: {
        img1: require('@/assets/images/lightSignal/oner.png'),
        img2: require('@/assets/images/lightSignal/L.png'),
        img3: require('@/assets/images/lightSignal/RL.png'),
        img4: require('@/assets/images/lightSignal/tr.png'),
      },
      xData: 'A',
      lightList: [
        {
          lampList: [],
          lampType: null,
          lightType: null,
          hasLightHuman: false,
          hasButton: false,
        },
      ],
      currSetting: {
        lampType: 'img1',
        maintDate: null,
        gnteeDate: null,
        type: 'full',
      },
      modalLight: false,
      currLightList: null,
    }
  },
  methods: {
    addLightList() {
      const newLightbox = {
        lampList: [],
        lampType: null,
        lightType: null,
        hasLightHuman: false,
        hasButton: false,
      }
      this.lightList.push(newLightbox)
    },
    showModalLight(i) {
      this.modalLight = true
      this.currLightList = i
    },
    saveProcess() {
      const addData = {
        lampType: this.currSetting.lampType,
        maintDate: this.currSetting.maintDate,
        gnteeDate: this.currSetting.gnteeDate,
        type: this.currSetting.type,
      }
      this.lightList[this.currLightList].lampList.push(addData)
      // restore
      this.currSetting.lampType = 'light1'
      this.currSetting.maintDate = null
      this.currSetting.gnteeDate = null
      this.currSetting.type = 'full'
      this.modalLight = false

      console.log(this.lightList)
    }
  },
}
</script>

<style>
.fixed-size-img {
  width: 60px;
  height: 100px;
}

.map-size {
  width: 75%;
  height: 500px;
}
.center-element {
  display: flex;
  align-items: center;
  justify-content: center;
  height: 100%;
  padding-top: 20;
}
.light-container {
  width: 100%;
}
</style>
